// A2D.cpp
//  Created on: Apr 25, 2013
//      Author: Tod
// Copyright (c) 2013 Syncor Systems, Inc.
// Based on NetBurner (c) 2012  SampleA2D class

#include "A2D.h"
#include <sim.h>

void A2D::InitSingleEnd()
{
    volatile unsigned short vw;

    //See MCF5441X RM Chapter 29
    sim2.adc.cr1 = 0;
    sim2.adc.cr2 = 0;
    sim2.adc.zccr = 0;
    sim2.adc.lst1 = 0x3210; //Ch 0....
    sim2.adc.lst2 = 0x7654; //ch 7 in result 0..7
    sim2.adc.sdis = 0; //All channels enabled
    sim2.adc.sr = 0xFFFF;
    for (int i = 0; i < 8; ++i)
    {
        vw = sim2.adc.rslt[i];
        sim2.adc.ofs[i] = 0;
    }

    sim2.adc.lsr = 0xFFFF;
    sim2.adc.zcsr = 0xFFFF;

    sim2.adc.pwr = 0; //Everything is turned on
    sim2.adc.cal = 0x0000;
    sim2.adc.pwr2 = 0x0005;
    sim2.adc.div = 0x505;
    sim2.adc.asdiv = 0x13;

}

unsigned short A2D::GetResult(const int ch) //Get the AD Result
{
    return sim2.adc.rslt[ch];
}

void A2D::Start()
{
    sim2.adc.sr = 0xffff;
    sim2.adc.cr1 = 0x2000;
}

bool A2D::IsDone()
{
    if (sim2.adc.sr & 0x0800) return true;
    else return false;
}

unsigned short A2D::Read(const int ch)
{
    Start();
    while (!IsDone())
        asm("nop");
    return GetResult(ch);
}

