//
// HtmlCCallbacks.c
//
//  Created on: Dec 9, 2009
//      Author: Tod
//

#include <iosys.h> //for writestring
#include <sstream>
#include <iostream>
#include "HtmlServices.h"
#include "ShellCommon.h"


using namespace std;
//==============================================================================
// Simple sample code to show how to implement a function callback from
// webpage
//==============================================================================
extern "C"
{
	void WriteStartupBanner(const int sock, const char* const /*url*/)
	{
		ostringstream display_stream;
		display_stream << "<h3>" << NShell::SHELL_IDN_RESPONSE << " " << NShell::FIRMWARE_REV_MSG << "</h3>";
		writestring(sock, display_stream.str().c_str());
	}

	//==============================================================================
	// THIS IS HERE FOR MOSTLY HISTORICAL/EDUCATION PURPOSES
	// You can achieve the same thing a bit cleaner by using AJAX calls. But there
	// may be a use where writing script directly into the head of a doc is still
	// useful so I'm leaving this technique in here.
	// A callback method from the web page.
	// Send hidden info from the server to the browser. Used to allow javascripts
	// to setup gui elements to values that reflect the state of the machine.
	// Data is stored in an object with properties using object literal syntax like
	// var machineState_ =
	// {
	//     debugState: 3,
	//     checkboxState: true
	// };
	// @param sock passed in by NB 0 the socket we will write out to
	// @param url - unused.
	//==============================================================================
	void WriteSystemVarsToJavaScript(const int sock, const char* const /*url*/)
	{
		cout << endl << "WriteSystemVarsToJavaScript() has been called" << endl;
		HtmlServices::WriteJsonMachineState(sock);
	}

	//==============================================================================
	// Example function that can be called via AJAX. This one handles multiple
	// request..
	//==============================================================================
	void AjaxCallback(const int sock, const char* const url)
	{
		HtmlServices::ProcessAjaxFunction(sock, url);
		return;
	}

}
