//
// HtmlServices.h
//
// Created on: Nov 18, 2009
//     Author: Tod
//

#ifndef HTMLSERVICES_H_
#define HTMLSERVICES_H_

#include <vector>
#include <map>
#include <iosfwd>
#include <sstream>
#include <utils.h> //has TimeTick

class HtmlServices
{
    public:
        HtmlServices();
        //void GetTempTorqueTable(char* outMsg);
        static int PostHandler(int sock,  char * const  url, char * const pData, char * const rxBuffer);
        void RegisterPost() const;
        static void WriteJsonMachineState(int sock);

        static void ProcessAjaxFunction(int sock, std::string url);

    private:
        static bool _testCheckbox;
        typedef void (*ptrToAjaxFunction)(int sock);
        static const std::string _requestToken;

        static void WriteSampleJsonData(int sock);
        static void WriteDropDownOptionsJsonData(int sock);
        static void WriteSampleUiData(int sock);
        static void WriteSampleResultData(int sock);
        static double GetRandomNumber();


        typedef std::map<std::string, ptrToAjaxFunction> AjaxFunctionMap;
        static AjaxFunctionMap AjaxCommands;
        template <typename T>
        static std::string AppendTimeTick(T value)
        {
            std::ostringstream os;
            os << value << ' ' << TimeTick;
            return os.str();
        }


};

#endif /* HTMLSERVICES_H_ */
