
#include <iostream>
#include <startnet.h>
#include "Framework/Startup.h"
#include "Framework/ServiceProvider.h"
#include "A2D.h"

//=============================================================================
// AJAX SAMPLE V3
// This project was designed to use some more sophisticated JavaScript libraries
// including jQuery and Knockout. It alos uses the Twitter Bootstrap styling
// library. It was also written against the newer MOD5441x dev board although except
// for the A2D code everything should work on modules like the MOD5272 as well. You'll
// need to test your specific card and module.
// The first version used the lower level HttpXmlRequest directly and there is an
// associated white paper explaining its use. The second verion became more sophisticated
// and used the Prototype library and many functions from my custom AJAX library.
// This version has very little of my own AJAX code since most of what I wrote is now
// available in jQuery.
// The real motivation for this third version was the Knockout library. It supports data
// binding and the MVVM design pattern. You'll notice that it also supports its own
// extremely clean and simple templating engine. You can bind a bunch of data that comes
// back from the NetBUrner with a single statement like data-bind="foreach: dataCollection"
// I know all my future web based interfaces will be using Knockout or something similar
// binding by hand and manually keeping things in synch is dead.
//
//
//Permission is hereby granted, free of charge, to any person obtaining a copy
//of this software and associated documentation files (the "Software"), to deal
//in the Software without restriction, including without limitation the rights
//to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
//copies of the Software, and to permit persons to whom the Software is
//furnished to do so, subject to the following conditions:

//THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
//IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
//FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
//AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
//LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
//OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
//SOFTWARE.
//=============================================================================
using namespace std;

extern "C" {
void UserMain(void * pd);
}

OS_MBOX _TcpMailBox ;


const char * AppName="NBShell_V3";

void UserMain(void * pd) {
    InitializeStack();
    cout << AppName  << " Application started " << endl;

    A2D::InitSingleEnd();
   Startup startup_app(ServiceProvider::GetHtmlServiceAsSingleton(),
					   ServiceProvider::GetTcpServerAsSingleton(),
					   ServiceProvider::GetTcpServerResetAsSingleton());
   startup_app.ShellInit(); //won't ever return

}
